/**********************************************************************
  el̃_vR}h
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	dump_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
struct	TARGET_TBL_STRUCT{
	char    *name ;
	int     flag ;
} ;
static struct TARGET_TBL_STRUCT trg_tbl[] = {
	{ "reg"			, PRINT_GPR_AND_OTHERS },
	{ "r"			, PRINT_GPR_AND_OTHERS },
	{ "allreg"		, PRINT_ALLREGISTERS   },
	{ "a"			, PRINT_ALLREGISTERS   },
	{ "mem"			, PRINT_MEMORYDUMP     },
	{ "m"			, PRINT_MEMORYDUMP     },
	{ NULL			, 0 }		/*** e[uI[ ***/
} ;
static int    start_adrs=-1 ;
int    i ;
int    flag ;
int    id ; 

 id=proc_list.cur_id ;
 if( tk_pt->pt[1]==NULL ){
   fprintf(simmsgfp,"sĂ܂\n") ;
   return(SPECIFY_ERROR) ;
 }
 
 for( i=0 ; ; i++ ){
   if( trg_tbl[i].name==NULL ){
     fprintf(simmsgfp,"Ɍ肪܂(%s)\n",tk_pt->pt[1]) ;
     return(SPECIFY_ERROR) ;
   }
   if( strcmp(tk_pt->pt[1],trg_tbl[i].name)==0 ){
     flag=trg_tbl[i].flag ;
     break ;
   }
 }
 
 if( flag==PRINT_GPR_AND_OTHERS || flag==PRINT_ALLREGISTERS ){
   return( print_regs( &proc_list.proc[id], flag ) ) ;
 }
 
 if( flag==PRINT_MEMORYDUMP ){
   if( tk_pt->pt[2]!=NULL ){
     i=exatoi(tk_pt->pt[2]) ;
     if( i<0 || i>=proc_list.proc[id].mem_size ) ;
     else start_adrs= i ;
   }else{
      start_adrs=-1 ;
   }
   return( print_mems( &proc_list.proc[id], start_adrs ) ) ;
 }
 
 return(NORMAL_EXIT) ;
}
