/**********************************************************************
  sR}h
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"

int	op_fetch( struct MACHINE_RESOURCE *mres ) ;
int	op_exec1( struct MACHINE_RESOURCE *mres ) ;

int	go_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int	excp ;
int	i ;
int	break_flag ;
int     id ;
static	int step_num=1 ;


 id=proc_list.cur_id ;
 break_flag=ON ;
 if( (mode & GO_STEP_MODE)==0 ){
   //݂pcbreak_ptƓꍇ͋^IɃu[N|Cg𖳌ɂ
   if( proc_list.proc[id].bp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].break_pt[i] ){
	 break_flag=OFF ;
	 break ;
       }
     }
   }
   while ( -1 ) {
     excp = op_fetch( &proc_list.proc[id] ) ;
     //pcCNg̎ȃ`FbN.ԈႢȂop_fetchƋ
     //while̊Oɒǂo
     if( excp !=0 ){
       fprintf(simmsgfp,"PC Boundary Error.\n") ;
       break ;
     }

     if( break_flag==ON && proc_list.proc[id].bp_num > 0 ){
       for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
	 if( proc_list.proc[id].pc==proc_list.proc[id].break_pt[i] ){
	   break_flag=OFF ;
	   fprintf(simmsgfp,"Exec stop by break point.\n") ;
	   fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   return(NORMAL_EXIT) ;
	 }
       }
     }

     if( break_flag==ON && iexe_count==proc_list.proc[id].break_inum ){
       fprintf(simmsgfp,"Exec stop by break num of exec instruction.\n") ;
       fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
	       proc_list.proc[id].pc,
	       proc_list.proc[id].inst) ;
       break ;
     }

     if( proc_list.proc[id].pp_num > 0 ){
       for( i=0 ; i<proc_list.proc[id].pp_num ; i++ ){
	 if( proc_list.proc[id].pc==proc_list.proc[id].pass_pt[i] ){
	   switch( pp_msg ){
	   case PP_DUMP_PC :
	     fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		     proc_list.proc[id].pc,
		     proc_list.proc[id].inst) ;
	     break ;
	   case PP_DUMP_GPR :
	     fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		     proc_list.proc[id].pc,
		     proc_list.proc[id].inst) ;
	     print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
	     break ;
	   case PP_DUMP_ALL :
	     fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		     proc_list.proc[id].pc,
		     proc_list.proc[id].inst) ;
	     print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
	     break ;
	   default :
	   }
	   break ;
	 }
       }
     }
     break_flag=ON ;
     trace_history[trace_ptr].pc   = proc_list.proc[id].pc ;
     trace_history[trace_ptr].inst = proc_list.proc[id].inst ;
     trace_ptr++ ;
     trace_ptr=trace_ptr%HISTORY_SIZE ;
     iexe_count++ ;
     if( iexe_count==0x80000000 ){
       iexe_count =0 ;
       iexe_count2++ ;
     }
     if( (mode & (GO_ALL_DUMP | GO_GPR_DUMP | GO_PC_DUMP))!=0 ){
       fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
	       proc_list.proc[id].pc,
	       proc_list.proc[id].inst) ;
     }
     if( (mode & GO_GPR_DUMP)!=0 ){
       print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
     }
     if( (mode & GO_ALL_DUMP)!=0 ){
       print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
     }
     
     excp = op_exec1( &proc_list.proc[id] ) ;
     if( excp !=0 ){
       if( (mode & (GO_ALL_DUMP | GO_GPR_DUMP | GO_PC_DUMP))==0 ){
	 fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
		 proc_list.proc[id].pc,
		 proc_list.proc[id].inst) ;
       }
       switch( excp ){
       case UNKNOWN_INSTRUCTION :
	 fprintf(simmsgfp,"Unknown Instruction.\n") ;
	 break ;
       case DIVIDED_BY_ZERO :
	 fprintf(simmsgfp,"Divided by Zero.\n") ;
	 break ;
       case INVALID_BO :
	 fprintf(simmsgfp,"BO is invalid.\n") ;
	 break ;
       case INSTFORM_IS_INVALID :
	 fprintf(simmsgfp,"Instruction format is invalid.\n") ;
	 break ;
       case UNKNOWN_SYSCALL_NO :
	 fprintf(simmsgfp,"Unknown SystemCall Number.\n") ;
	 break ;
       case NOT_IMPLEMENTED_OP :
	 fprintf(simmsgfp,"Not implemented operation.\n") ;
	 break ;
       case MEM_AREA_OVER :
	 fprintf(simmsgfp,"Memory access area is over.\n") ;
	 break ;
       case SYSCALLED_EXIT :
	 fprintf(simmsgfp,"exit() was called. Simulation is stopped.\n") ;
	 break ;
       default :
	 fprintf(simmsgfp,"PPCSIM internal error.\n") ;
       }
       break ;
     }
   }
 }else{	// Xebvs[h
   if( tk_pt->pt[1]!=NULL ){
     i=exatoi( tk_pt->pt[1] ) ;
     if( i>0 ) step_num=i ;
   }
   for( i=0 ; i<step_num ; i++ ){
     excp = op_fetch( &proc_list.proc[id] ) ;
     //pcCNg̎ȃ`FbN.ԈႢȂop_fetchƋ
     //for̊Oɒǂo
     if( excp !=0 ){
       fprintf(simmsgfp,"PC Boundary Error.\n") ;
       break ;
     }
     trace_history[trace_ptr].pc   = proc_list.proc[id].pc ;
     trace_history[trace_ptr].inst = proc_list.proc[id].inst ;
     trace_ptr++ ;
     trace_ptr=trace_ptr%HISTORY_SIZE ;
     iexe_count++ ;
     if( iexe_count==0x80000000 ){
       iexe_count =0 ;
       iexe_count2++ ;
     }
     if( (mode & (GO_ALL_DUMP | GO_GPR_DUMP | GO_PC_DUMP))!=0 ) {
       fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
	       proc_list.proc[id].pc,
	       proc_list.proc[id].inst) ;
     }
     if( (mode & GO_GPR_DUMP)!=0 ){
       print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
     }
     if( (mode & GO_ALL_DUMP)!=0 ){
       print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
     }
     
     if( proc_list.proc[id].pp_num > 0 ){
       for( i=0 ; i<proc_list.proc[id].pp_num ; i++ ){
	 if( proc_list.proc[id].pc==proc_list.proc[id].pass_pt[i] ){
	   switch( pp_msg ){
	   case PP_DUMP_PC :
	     fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		     proc_list.proc[id].pc,
		     proc_list.proc[id].inst) ;
	     break ;
	   case PP_DUMP_GPR :
	     fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		     proc_list.proc[id].pc,
		     proc_list.proc[id].inst) ;
	     print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
	     break ;
	   case PP_DUMP_ALL :
	     fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		     proc_list.proc[id].pc,
		     proc_list.proc[id].inst) ;
	     print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
	     break ;
	   default :
	   }
	   break ;
	 }
       }
     }
     excp = op_exec1( &proc_list.proc[id] ) ;
     if( excp !=0 ){
       switch( excp ){
       case UNKNOWN_INSTRUCTION :
	 fprintf(simmsgfp,"Unknown Instruction.\n") ;
	 break ;
       case DIVIDED_BY_ZERO :
	 fprintf(simmsgfp,"Divided by Zero.\n") ;
	 break ;
       case INVALID_BO :
	 fprintf(simmsgfp,"BO is invalid.\n") ;
	 break ;
       case INSTFORM_IS_INVALID :
	 fprintf(simmsgfp,"Instruction format is invalid.\n") ;
	 break ;
       case UNKNOWN_SYSCALL_NO :
	 fprintf(simmsgfp,"Unknown SystemCall Number.\n") ;
	 break ;
       case NOT_IMPLEMENTED_OP :
	 fprintf(simmsgfp,"Not implemented operation.\n") ;
	 break ;
       case MEM_AREA_OVER :
	 fprintf(simmsgfp,"Memory access area is over.\n") ;
	 break ;
       case SYSCALLED_EXIT :
	 fprintf(simmsgfp,"exit() was called. Simulation is stopped.\n") ;
	 break ;
       default :
	 fprintf(simmsgfp,"PPCSIM internal error.\n") ;
       }
       break ;
     }
   }
 }
 
 return(NORMAL_EXIT) ;
}
