/*********************************************************************************
  vZbT`
  $Id:$
*********************************************************************************/

/********************************************************************************
  ʎ
  XER,LR,CTR,FLGRw
*********************************************************************************/
#define SPR_NUM 1024
unsigned int MSR       ; /**}VXe[^XWX^                  **/
unsigned int SR[16]    ; /**ZOgWX^                        **/
unsigned int SPR[SPR_NUM] ; /**XyVp[pXWX^                **/

/**
 WX^
 64bitvZbT[hׂɁA[hˑ̃WX^
 32bit*2Ƃ ???u,???l ƂOtB32bitvZbT
 ???lgpB
**/
#define	GPR_NUM		32
#define	FPR_NUM		32

struct	GPR_STRUCT{
	unsigned int	ru ;
	unsigned int	rl ;
} ;

struct	FPR_STRUCT{
	double	f ;
} ;

struct	FLAG_STRUCT{
	unsigned int	cr[8] ;
	unsigned int	fpscr ;
	unsigned int	xer ;
	unsigned int	lru ;
	unsigned int	lrl ;
	unsigned int	ctru ;
	unsigned int	ctrl ;
} ;


/*********************************************************************************
  XER  bit0 : SO
       bit1 : OV
       bit2 : CA
       bit3-24 : Reserved
       bit25-31 : SS
  -----------------------
  CR0  bit0 : LT()
       bit1 : GT()
       bit2 : EQ()
       bit3 : SO<=XER.SO̒lRs[
*********************************************************************************/

/**
  vZXL }V\
**/
#define MAX_BREAK_POINT_NUM   16
#define MAX_PASS_POINT_NUM    16

struct MACHINE_RESOURCE{
  struct GPR_STRUCT  GPR[GPR_NUM] ;
  struct FPR_STRUCT  FPR[FPR_NUM] ;
  struct FLAG_STRUCT FLGR         ;
  unsigned int       *SPR[1024]   ;
  unsigned int       *MSR         ;
  unsigned int       *SR[16]      ;
  int                pc           ;
  unsigned char      *mem         ;
  int                mem_size     ;
  int                heap_top     ;
  int                heap_size    ;
  int                id           ;
  unsigned int       child_exit_code ;
  unsigned int       child_signal ;
  unsigned int       inst         ;

  /** V~[^\[X **/
  int                break_pt[MAX_BREAK_POINT_NUM] ; 
  int                bp_num       ;
  int                pass_pt[MAX_PASS_POINT_NUM] ;
  int                pp_num       ;
  int                break_inum   ; //sߐŎ~߂
} ;

/**
  vZXXg
**/
#define MAX_PROCESS_ID 16

struct PROCESS_LIST{
  int cur_id ;
  struct MACHINE_RESOURCE proc[MAX_PROCESS_ID] ;
} proc_list ;

/**
  }V\[X蓖ăftHg
**/

#define DEFAULT_MEMSIZE    (8*1024*1024)
int default_memsize ;

#define DEFAULT_HEAPTOP    (2*1024*1024)
int default_heaptop ;

#define DEFAULT_EXEC_START (0x10000)
int default_exec_start ;

#define DEFAULT_STACK_TOP  (0xff00)
int default_stack_top ;

int   create_proc( struct PROCESS_LIST *proc_list , int memsize ) ;
int   remove_proc( struct PROCESS_LIST *proc_list ) ;
//int   sim_eload( struct MACHINE_RESOURCE *mres , char *fname ) ;
int   elf_load( struct MACHINE_RESOURCE *mres , char *fname ) ;
int   sim_setarg( struct MACHINE_RESOURCE *mres , struct TOKEN_STRUCT *tk_pt , int start ) ;
int   sim_fork( struct PROCESS_LIST *proc_list ) ;
void  init_regs( struct MACHINE_RESOURCE *mres ) ;

#define	PRINT_GPR_AND_OTHERS   0
#define	PRINT_ALLREGISTERS     1
#define	PRINT_MEMORYDUMP       2
int   print_regs( struct MACHINE_RESOURCE *mres, int ) ;
int   print_mems( struct MACHINE_RESOURCE *mres, int ) ;

