/**********************************************************************
  VKvZX(}V\[X)̒ǉ
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	create_proc( struct PROCESS_LIST *proc_list, int memsize )
{
int id ;
struct MACHINE_RESOURCE *mres ;

  proc_list->cur_id++ ;
  id   = proc_list->cur_id ;
  mres = &proc_list->proc[id] ;

  if( mres->mem!=NULL ){
    free(mres->mem) ;
    mres->mem=NULL ;
    mres->mem_size=0 ;
  }
  
  mres->mem=malloc(memsize) ;
  
  if( mres->mem==NULL ){
    fprintf(simmsgfp,"mۂł܂ł(size=%d)\n", memsize ) ;
    return(MEM_ALLOC_ERROR) ;
  }
  memset( mres->mem, 0, memsize ) ;
  init_regs( mres ) ;
  mres->mem_size = memsize ;
  mres->heap_top = default_heaptop ;
  mres->heap_size= 0 ;
  mres->pc       = default_exec_start ;
  mres->GPR[1].rl= default_stack_top ;
  mres->id       = id ;

  return(NORMAL_EXIT) ;
}
