/**********************************************************************
  SPR֘At
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

void	init_regs( struct MACHINE_RESOURCE *mres )
{
int i ;

 //肠SĂSPR̂Ɍт 
 for( i=0 ; i<SPR_NUM ; i++ ){
   mres->SPR[i]=&SPR[i] ;
 }
 
 mres->SPR[1] = &mres->FLGR.xer  ; // XER
 mres->SPR[8] = &mres->FLGR.lrl  ; // LR
 mres->SPR[9] = &mres->FLGR.ctrl ; // CTR
 mres->SPR[9] = &mres->FLGR.ctrl ; // CTR
 
 mres->MSR    = &MSR             ; // MSR
 mres->SR[ 0] = &SR[ 0]          ; // SR0
 mres->SR[ 1] = &SR[ 1]          ; // SR1
 mres->SR[ 2] = &SR[ 2]          ; // SR2
 mres->SR[ 3] = &SR[ 3]          ; // SR3
 mres->SR[ 4] = &SR[ 4]          ; // SR4
 mres->SR[ 5] = &SR[ 5]          ; // SR5
 mres->SR[ 6] = &SR[ 6]          ; // SR6
 mres->SR[ 7] = &SR[ 7]          ; // SR7
 mres->SR[ 8] = &SR[ 8]          ; // SR8
 mres->SR[ 9] = &SR[ 9]          ; // SR9
 mres->SR[10] = &SR[10]          ; // SR10
 mres->SR[11] = &SR[11]          ; // SR11
 mres->SR[12] = &SR[12]          ; // SR12
 mres->SR[13] = &SR[13]          ; // SR13
 mres->SR[14] = &SR[14]          ; // SR14
 mres->SR[15] = &SR[15]          ; // SR15

 mres->FLGR.cr[0]=0x00000000 ;
 mres->FLGR.cr[1]=0x00000000 ;
 mres->FLGR.cr[2]=0x00000000 ;
 mres->FLGR.cr[3]=0x00000000 ;
 mres->FLGR.cr[4]=0x00000000 ;
 mres->FLGR.cr[5]=0x00000000 ;
 mres->FLGR.cr[6]=0x00000000 ;
 mres->FLGR.cr[7]=0x00000000 ;
 mres->FLGR.xer  =0x00000000 ;
 mres->FLGR.ctru =0x00000000 ;
 mres->FLGR.ctrl =0x00000000 ;
 mres->FLGR.lru  =0x00000000 ;
 mres->FLGR.lrl  =0x00000000 ;
 for( i=0 ; i<GPR_NUM ; i++ ){
   mres->GPR[i].rl =0x00000000 ;
 }
 for( i=0 ; i<FPR_NUM ; i++ ){
   mres->FPR[i].f = 0.0 ;
 }
 
 mres->pc=0 ;
}
