/***
  ANZX}N(œK̓RpCɂ΂Ă炤)
  d s*b,u*̎GPRAf*b,d*b̎FPR 鎖B
***/
#ifdef LITTLE_ENDIAN
#define	fetchs2b(d,a)	{unsigned char *uc;\
                         d=0;uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[(a)+1];\
                         uc[1]=mres->mem[(a)+0];\
                         if( (uc[1]&0x80)!=0 ){\
                           uc[2]=0xff;uc[3]=0xff;\
                         }}
#define	fetchu1b(d,a)	{unsigned char *uc;\
                         d=0;uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[(a)+0];}
#define	fetchu2b(d,a)	{unsigned char *uc;\
                         d=0;uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[(a)+1];\
                         uc[1]=mres->mem[(a)+0];}
#define	fetchu4b(d,a)	{unsigned char *uc;\
                         d=0;uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[(a)+3];\
                         uc[1]=mres->mem[(a)+2];\
                         uc[2]=mres->mem[(a)+1];\
                         uc[3]=mres->mem[(a)+0];}
#define	fetchf4b(d,a)	{unsigned char *uc;\
                         float f ;\
                         uc=&f;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[(a)+3];\
                         uc[1]=mres->mem[(a)+2];\
                         uc[2]=mres->mem[(a)+1];\
                         uc[3]=mres->mem[(a)+0];\
                         d=f;}
#define	fetchd8b(d,a)	{unsigned char *uc;\
                         d=0;uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[(a)+7];\
                         uc[1]=mres->mem[(a)+6];\
                         uc[2]=mres->mem[(a)+5];\
                         uc[3]=mres->mem[(a)+4];\
                         uc[4]=mres->mem[(a)+3];\
                         uc[5]=mres->mem[(a)+2];\
                         uc[6]=mres->mem[(a)+1];\
                         uc[7]=mres->mem[(a)+0];}

#define	storeu1b(d,a)	{unsigned char *uc;\
                         uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         mres->mem[(a)+0]=uc[0];}
#define	storeu2b(d,a)	{unsigned char *uc;\
                         uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         mres->mem[(a)+0]=uc[1];\
                         mres->mem[(a)+1]=uc[0];}
#define	storeu4b(d,a)	{unsigned char *uc;\
                         uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         mres->mem[(a)+0]=uc[3];\
                         mres->mem[(a)+1]=uc[2];\
                         mres->mem[(a)+2]=uc[1];\
                         mres->mem[(a)+3]=uc[0];}
#define	storef4b(d,a)	{unsigned char *uc;\
                         float f;\
                         f=d;uc=&f;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         mres->mem[(a)+0]=uc[3];\
                         mres->mem[(a)+1]=uc[2];\
                         mres->mem[(a)+2]=uc[1];\
                         mres->mem[(a)+3]=uc[0];}
#define	stored8b(d,a)	{unsigned char *uc;\
                         uc=&d;\
                         if( (a)>=mres->mem_size || mres->mem_size<0 ) \
                         return(MEM_AREA_OVER);\
                         mres->mem[(a)+0]=uc[7];\
                         mres->mem[(a)+1]=uc[6];\
                         mres->mem[(a)+2]=uc[5];\
                         mres->mem[(a)+3]=uc[4];\
                         mres->mem[(a)+4]=uc[3];\
                         mres->mem[(a)+5]=uc[2];\
                         mres->mem[(a)+6]=uc[1];\
                         mres->mem[(a)+7]=uc[0];}
#else
#define	fetchs2b(d,a)	{short *sh;\
                         sh=&mres->mem[(a)];\
                         (d)=*sh;}
#define	fetchu1b(d,a)	{(d)=mres->mem[(a)];}
#define	fetchu2b(d,a)	{unsigned short *us;\
                         us=&mres->mem[(a)];\
                         (d)=*us;}
#define	fetchu4b(d,a)	{unsigned int *ui;\
                         ui=&mres->mem[(a)] ;\
                         (d)=*ui;}
#define	fetchf4b(d,a)	{float *fl;\
                         fl=&mres->mem[(a)] ;\
                         (d)=*f;}
#define	fetchd8b(d,a)	{double *db;\
                         db=&mres->mem[(a)] ;\
                         (d)=*db;}
#define	storeu1b(d,a)	{(d)=mres->mem[(a)  ];}
#define	storeu2b(d,a)	{unsigned short *us;\
                         us=&mres->mem[(a)];\
                         *us=d;}
#define	storeu4b(d,a)	{unsigned int *ui;\
                         ui=&mres->mem[(a)] ;\
                         *ui=(d);}
#define	storef4b(d,a)	{float *fl;\
                         fl=&mres->mem[(a)] ;\
                         *fl=(d);}
#define	stored8b(d,a)	{double *db;\
                         db=&mres->mem[(a)] ;\
                         *db=(d);}
#endif /**LITTLE_ENDIAN**/

int	memory_copy( struct MACHINE_RESOURCE *, int, int, int ) ;

