/**********************************************************************
  _v
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"


int	print_mems( struct MACHINE_RESOURCE *mres, int start_adrs )
{
int i,j ;
static char disp_str[16+2] ;
static	int dump_mem_adrs=0 ;

 if( start_adrs >= 0 ) dump_mem_adrs=start_adrs ;
 
 disp_str[16]='\0' ;
 disp_str[17]='\0' ;
 for( j=0 ; j<8 ; j++ ){
   fprintf(simmsgfp,"%08x :",dump_mem_adrs) ;
   for( i=0 ; i<16 ; i++ ){
     if( (isgraph( mres->mem[dump_mem_adrs+i] )!=0) ||
	 (mres->mem[dump_mem_adrs+i]==' ') ){
       disp_str[i]=mres->mem[dump_mem_adrs+i] ;
     }else{
       disp_str[i]='.' ;
     }
     fprintf(simmsgfp," %02X",mres->mem[dump_mem_adrs+i] ) ;
   }
   fprintf(simmsgfp," %s",disp_str) ;
   fprintf(simmsgfp,"\n") ;
   dump_mem_adrs+=16 ;
 }
 
 return(NORMAL_EXIT) ;
}
