/**********************************************************************
  sarg̃Zbg
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

#define ARG_START       0x0200
#define ARG_STR_TOP     0x0300

int	sim_setarg( struct MACHINE_RESOURCE *mres , struct TOKEN_STRUCT *tk_pt , int start )
{
int i ;
int arg_start ;
int arg_str_top ;
int len ; 

 arg_start   = ARG_START ;
 arg_str_top = ARG_STR_TOP ;

 mres->GPR[3].rl=(tk_pt->num-start) ; /*** argc̐ݒ ***/
 mres->GPR[4].rl=arg_start          ; /*** argv̐ݒ ***/

 for( i=start ; i<tk_pt->num ; i++ ){
   mres->mem[arg_start+0]=(arg_str_top & 0xff000000)>>24 ;
   mres->mem[arg_start+1]=(arg_str_top & 0x00ff0000)>>16 ;
   mres->mem[arg_start+2]=(arg_str_top & 0x0000ff00)>> 8 ;
   mres->mem[arg_start+3]=(arg_str_top & 0x000000ff)     ;
   arg_start+=4 ;

   len = strlen( tk_pt->pt[i] ) ;
   strcpy( &mres->mem[arg_str_top], tk_pt->pt[i] ) ;
   arg_str_top += len ;
   mres->mem[arg_str_top]='\0' ;
   arg_str_top++ ;
 }

 return( NORMAL_EXIT ) ;
}
